from typing import List, Optional
from pydantic import BaseModel
from tracardi_plugin_sdk.action_runner import ActionRunner

from .port_to_port_edges import PortToPortEdges


class Graph(BaseModel):
    in_edges: PortToPortEdges = PortToPortEdges()
    out_edges: PortToPortEdges = PortToPortEdges()


class Node(BaseModel):
    id: str
    inputs: Optional[List[str]] = []
    outputs: Optional[List[str]] = []
    className: str
    module: str
    init: Optional[dict] = {}
    object: Optional[ActionRunner] = None
    graph: Graph = Graph()

    class Config:
        arbitrary_types_allowed = True

    def is_condition(self):
        return self.module == 'functions.class_calls' and self.className == 'Conditional'
